﻿using System;
using System.IO;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;

namespace ABetterJsonExperience
{
    class Program
    {
        static void Main(string[] args)
        {
            Program p = new Program();
            string elasticSearchJson = p.GetElasticSearchQuery("Joe", 0, 5);
            Console.WriteLine(elasticSearchJson);

            string elasticSearchJson2 = p.GetElasticSearchQuery2("Smith", "Ohio");
            Console.WriteLine(elasticSearchJson2);
        }

        private string GetElasticSearchQuery(string fullName, int from, int size)
        {
            string elasticSearchQuery = File.ReadAllText("ElasticSearchQuery.json");
            dynamic workableElasticSearchQuery = JsonConvert.DeserializeObject(elasticSearchQuery);

            workableElasticSearchQuery.query.match_phrase_prefix.fullName = fullName;
            workableElasticSearchQuery.from = from;
            workableElasticSearchQuery.size = size;

            return workableElasticSearchQuery.ToString();
        }

        private string GetElasticSearchQuery2(string lastName, string state)
        {
            string elasticSearchQuery2 = File.ReadAllText("ElasticSearchQuery2.json");
            dynamic workableElasticSearchQuery2 = JsonConvert.DeserializeObject(elasticSearchQuery2);

            workableElasticSearchQuery2.query.@bool.must[0].match_phrase_prefix.lastName = lastName;
            workableElasticSearchQuery2.query.@bool.must[1].match = new JObject(new JProperty("address.state", state));

            return workableElasticSearchQuery2.ToString();
        }
    }
}
